import 'dart:async';

import 'package:flutter/foundation.dart';
import 'package:flutter_mutation/mutation_cache.dart';

class MutationKey<R> {
  MutationKey();

  @override
  String toString() {
    return shortHash(this);
  }

  Future<R>? mutate(FutureOr<R> future, {bool append = false}) {
    return MutationCache.instance
        .getMutation(this)
        ?.mutate(future, append: append);
  }

  clear() {
    MutationCache.instance.getMutation(this)?.clear();
  }

  clearError() {
    MutationCache.instance.getMutation(this)?.clearError();
  }
}
